UNSIGNED int heure;
UNSIGNED int minute;
UNSIGNED int seconde;
UNSIGNED int jour;
UNSIGNED int mois;
UNSIGNED long annee;

const unsigned long base_annee = 2012;

unsigned int bcdtodecimal(UNSIGNED int bcd)
{
   UNSIGNED int result;  
   result = ( (bcd>>4) * 10 ) + (bcd & 0x0F);
   RETURN result;
}


void init_pcf8593(VOID)
{
   I2C_START (); // start
   I2C_WRITE (0XA2); // j'adresse en ecriture le composant 0xA2 PCF8593
   I2C_WRITE (0); // adresse du registre de configuration a ecrire 0
   I2C_WRITE (0); // valeur a mettre dans le registre de configuration
   I2C_STOP ();   // stop
}

Void Ecrire_date_pcf8593(void)
{
}
Void Ecrire_heure_pcf8593(void)
{
}
Void lire_date_heure_pcf8593(void)
{
   I2C_START ();     // start
   I2C_WRITE (0XA2); // j'adresse en lecture le composant 0xA2 PCF8593
   I2C_WRITE (2);    // j'indique que je lis le registre  2 = seconde
   I2C_START ();     // restart
   I2C_WRITE (0XA3); // j'adresse en lecture le composant PCF8593
   seconde = I2C_READ ();  // 2 on lit les secondes (BCD)
   seconde = bcdtodecimal(seconde);
   minute = I2C_READ ();  // 3 lecture minute  
   minute = bcdtodecimal(minute);  
   heure = I2C_READ ();   //4
   heure = bcdtodecimal(heure);  
   jour = I2C_READ ();    //5
   annee = jour;
   annee = (annee>>6) + base_annee;  // decalage droite pour garder annee et on ajoute 2012
   jour = bcdtodecimal  (jour&0x3F);  // masquage pour garder uniquement jour 
   mois = I2C_READ ();   //6
   mois = bcdtodecimal  (mois&0x1F);  // masquage pour garder mois    
   I2C_READ (); // 7 voir en pratique.
   I2C_READ (); // 8
   I2C_READ (); // 9
   I2C_READ (); // 10
   I2C_READ (); // 11
   I2C_READ (); // 12
   I2C_READ (); // 13
   I2C_READ (); // 14  
   I2C_READ (); // 15     
   I2C_STOP (); 

}

